Attribute VB_Name = "modKonverter"

' VISUAL BASIC WORLD
' ===========================================
' Das groe Portal zum Thema Visual Basic.
'
' Wenn Ihnen dieser Source Code gefallen hat,
' dann empfehlen Sie Visual Basic World bitte
' weiter und/oder setzen Sie einen Link auf:
'
' http://www.visualbasicworld.de/
'
' Vernetzen Sie sich mit uns:
'
' http://twitter.com/visualbasicwrld

Option Explicit

Public Function HexToDez(ByVal strHex As String) As Long

   '==========================================================='
   '= Fkt. wandelt eine Hexadezimalzahl ins Dezimalsystem um. ='
   '==========================================================='
   
   HexToDez = CLng("&H" & strHex)
      'Die eigentliche Hauptarbeit bernimmt fr uns die
      'Change-Long-Funktion. Diese berrerscht auch die
      'Umwandlung einer Hexadezimalzahl in das Zehnersystem.

End Function

Public Function HexToDez2(ByVal strHex As String) As Long

   '==========================================================='
   '= Fkt. wandelt eine Hexadezimalzahl ins Dezimalsystem um. ='
   '==========================================================='
   
   'Die Funktion HexToDez2 erledigt die selbe Aufgabe wie
   'HexToDez und dient lediglich der Veranschaulichung einer
   'mglichen Umsatzung in Source Code.
   
   Dim lngZhler As Long
   Dim lngMax As Long
   
   Dim strHexValue As String

   lngMax = Len(strHex)

   For lngZhler = 0 To (lngMax - 1)
   
      strHexValue = Mid$(strHex, lngMax - (lngZhler), 1)
      
      Select Case strHexValue
         Case "A": strHexValue = "10"
         Case "B": strHexValue = "11"
         Case "C": strHexValue = "12"
         Case "D": strHexValue = "13"
         Case "E": strHexValue = "14"
         Case "F": strHexValue = "15"
      End Select
   
      HexToDez2 = HexToDez2 + _
         CDbl(strHexValue) * (16 ^ lngZhler)
         
   Next
End Function
Public Function DezToHex(ByVal dblDezimal As Double) As String

   '====================================================='
   '= Fkt. rechnet eine Dezimalzahl in eine Hexzahl um. ='
   '====================================================='
   
   'Diese Funktion leistet das selbe wie die VB-Funktion Hex.
   'In einer Produktivanwendung empfiehlt sich der jedoch aus
   'Geschwindigkeitsgrnden der Einsatz der Hex-Funktion.
   
   Dim strHexValue As String
   
   DezToHex = ""

   Do
   
      strHexValue = dblDezimal Mod 16
   
      Select Case strHexValue
         Case 10: strHexValue = "A"
         Case 11: strHexValue = "B"
         Case 12: strHexValue = "C"
         Case 13: strHexValue = "D"
         Case 14: strHexValue = "E"
         Case 15: strHexValue = "F"
      End Select
            
      DezToHex = strHexValue & DezToHex
         
      dblDezimal = dblDezimal \ 16
         
   Loop Until dblDezimal < 1

End Function
